package com.gemho.netty.controller;

import cn.hutool.core.util.URLUtil;
import cn.hutool.http.HttpUtil;
import com.gemho.netty.model.ResultModel;
import com.gemho.netty.util.CRC16Util;
import com.gemho.netty.util.MapUtils;
import com.gemho.netty.util.ParamUtil;
import com.gemho.netty.util.StringUtil;
import io.netty.buffer.ByteBuf;
import io.netty.buffer.Unpooled;
import io.netty.channel.Channel;
import io.netty.channel.ChannelFuture;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.net.URLEncoder;

@RestController
public class SocketController {

    /**
     *
     * @param key  313233343536373839383736353433   16进制DTU码
     * @param code  01
     * @return String
     */
    @GetMapping("/clear")
    public String clearDiaplay(String key, String code) {
        String CLEAR_CODE = "0000000400006050";
        code = code + CLEAR_CODE;
        int i = CRC16Util.calcCrc16(StringUtil.hexString2Bytes(code));
        code = (code + StringUtil.hightAddZero(StringUtil.encodeHEX(i))).toUpperCase();
        // 内容封装
        ByteBuf bufff = Unpooled.buffer();
        //  bufff.clear();
        System.out.println("============send:" + code);
        bufff.writeBytes(StringUtil.hexString2Bytes(code));
        // 获取通道
        Channel mapChannel = MapUtils.getMapChannel(key);
        bufff.retain();
        mapChannel.writeAndFlush(bufff);
        // bufff.retain();

        // 返回失败指令时使用
        if (!ParamUtil.findMapContainerKey("clear" + mapChannel.remoteAddress().toString())) {
            ResultModel model = new ResultModel();
            model.setCount(1);
            model.setHexCodeByte(StringUtil.hexString2Bytes(code));
            ParamUtil.addMap("clear" + mapChannel.remoteAddress().toString(), model);
        }
        return "success";
    }


    /**
     *
     * @param key          313233343536373839383736353433   16进制DTU码
     * @param code         01
     * @param x            54  16进制
     * @param y            5   16禁止
     * @param font         31字体大小
     * @param content      温度
     * @return String
     */
    @GetMapping("/display")
    public String display(String key, String code, Integer x, Integer y, String font,String content) {
        try{
            String DISPLAY_CODE = "0001";
            // 指令处理
            String xHex = Integer.toHexString(x).length() == 1? "0"+ Integer.toHexString(x) : Integer.toHexString(x);
            String yHex = Integer.toHexString(y).length() == 1? "0"+ Integer.toHexString(y) : Integer.toHexString(y);
            String contentByte = StringUtil.enUnicode(content);
            byte[] contentB = StringUtil.hexString2Bytes(contentByte);
            String lenHex = StringUtil.encodeHEX(contentB.length + 3);
            lenHex = StringUtil.hightAddZero(lenHex);
            code = code + DISPLAY_CODE + lenHex + xHex + yHex + font + StringUtil.bytesToHexString(contentB);
            code = code + StringUtil.hightAddZero(StringUtil.encodeHEX(CRC16Util.calcCrc16(StringUtil.hexString2Bytes(code))));
            System.out.println("下发指令==============" + code.toUpperCase());
            // 数据封装
            ByteBuf bufff = Unpooled.buffer();
            bufff.writeBytes(StringUtil.hexString2Bytes(code));
            // 获取通道
            Channel mapChannel = MapUtils.getMapChannel(key);
            mapChannel.writeAndFlush(bufff);

            // bufff.retain();
            // 返回失败指令时使用
            if (!ParamUtil.findMapContainerKey("display" + mapChannel.remoteAddress().toString())) {
                ResultModel model = new ResultModel();
                model.setCount(1);
                model.setHexCodeByte(StringUtil.hexString2Bytes(code));
                ParamUtil.addMap("display" + mapChannel.remoteAddress().toString(), model);
            }
            return "success";
        }catch(Exception e) {
            e.printStackTrace();
            return null;
        }
    }
    @GetMapping("/test")
    public void test(String key) throws Exception{
        System.out.println(key + "=======================");
        String body = HttpUtil.createGet("http://localhost:9998/display?key=864333042029678&code=01&x=0&y=12&font=31&content=温 度:33.5℃").execute().body();
        // Thread.sleep(500);
        String body1 = HttpUtil.createGet("http://localhost:9998/display?key=864333042029678&code=01&x=0&y=24&font=31&content=湿 度:33.5%RH").execute().body();
        // Thread.sleep(500);
        String body2 = HttpUtil.createGet("http://localhost:9998/display?key=864333042029678&code=01&x=0&y=36&font=31&content=CO2:450ppm").execute().body();
    }
}
